#include "complexe.hpp"
#include <iostream>


//
// Ce programme cherche les racines complexes de X^5-1 par la methode de Newton
//


// Le polynome dont on cherche les racines...
complexe P(complexe z)
{
  return z*z*z*z*z-1;
}

// ... et sa derivee
complexe dP(complexe z)
{
  return 5*z*z*z*z;
}

// Le complexe obtenu a partir de z apres une iteration de la methode de Newton
complexe Newton(complexe z)
{
  return z - P(z)/dP(z);
}




int main(void)
{
  std::cout << "\nCalcul des racines de X^5-1 par la methode de Newton.\n";
  std::cout << "1 est racine évidente. Il en reste 4 à trouver.\n\n";
  
  
  // On part du complexe i
  complexe z=I;
  std::cout << "Valeur initiale : " << z << ".\tValeur de P(z) : " << P(z) << "\n";
  for (int n=1; n<=7; n++)
	{
	  z = Newton(z);
	  std::cout << "Apres " << n << " iterations : " << z << ".\tValeur de P(z) : " << P(z) << "\n";
	}
  std::cout << z << " est racine de X^5-1 (de meme que " << z.conj() << ").\n\n";
  
  
  
  std::cout << "Avec une autre condition initiale :" << "\n";
  z = -1+I;
  std::cout << "Valeur initiale : " << z << ".\tValeur de P(z) : " << P(z) << "\n";
  for (int n=1; n<=7; n++)
	{
	  z = Newton(z);
	  std::cout << "Apres " << n << " iterations : " << z << ".\tValeur de P(z) : " << P(z) << "\n";
	}
  std::cout << z << " est racine de X^5-1 (de meme que " << z.conj() << ").\n\n";

  
  return 0;
}
